local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local ScarfPriority = function(player)
			if player.mo.swordstate > 1
				CBW_Battle.SetPriority(player,1,1,nil,1,1,"Scarf Sword")
			end
			if player.mo.sworddash > 1
				CBW_Battle.SetPriority(player,1,2,nil,1,2,"Float Dash")
			end
			if player.mo.lightburst > 1
				CBW_Battle.SetPriority(player,20,0,nil,20,0,"Light Burst")
			end
			if player.powers[pw_sneakers]
			and player.speed >= player.runspeed
				CBW_Battle.SetPriority(player,2,2,nil,2,2,"Nitro Boost")
			end
		end
		local ScarfBattle = function(mo,doaction,pressedaction)
		local player = mo.player
		if not(CBW_Battle.CanDoAction(player))
			player.actionstate = 0
			return
		end
		if P_IsObjectOnGround(mo)
			player.actiontext = "Light Burst"
			player.actionrings = 10	
		else
			player.actiontext = "Plasma Shot"
			player.actionrings = 10
		end
		if player.actionstate != 0
			player.canguard = false
		end
		if player.actionstate == 0
		and not mo.scarfplasmabattle
		and not mo.swordstate
			if doaction == 1
				if P_IsObjectOnGround(mo)
					S_StartSound(mo, sfx_s3k78)
					S_StartSound(mo, sfx_s3k60)
					P_ResetPlayer(player)
					player.powers[pw_nocontrol] = 2
					mo.lightburst = 31
					S_StartSound(player.mo, sfx_s3k5f)
					//P_SpawnPlayerMissile(mo, MT_LIGHTBURST)
					local lightburst = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_LIGHTBURST)
					if lightburst and lightburst.valid
						lightburst.target = mo
					end
					CBW_Battle.PayRings(player)
					mo.state = S_PLAY_LIGHTBURST1
					mo.swordstate = 0
					mo.swordjump = 0
					mo.sworddash = 0
					CBW_Battle.ApplyCooldown(player,TICRATE*4)
				else
					CBW_Battle.PayRings(player)
					S_StartSound(mo,sfx_s3k7a)
					mo.scarfplasmabattle = 1*TICRATE
					CBW_Battle.ApplyCooldown(player, 3*TICRATE)
				end
			end
		end
		if mo.lightburst > 1
			player.guard = 3
		else
			if player.guard >= 3
				player.guard = 0
			end
		end
		if mo.swordstate > 1
			player.canguard = false
			if mo.swordstate == 1
				player.canguard = true
			end
		end
		if mo.sworddash > 1
			player.canguard = false
			if mo.sworddash == 1
				player.canguard = true
			end
		end
		if mo.swordjump > 1
			player.canguard = false
			if mo.swordjump == 1
				player.canguard = true
			end
		end
	end
	CBW_Battle.SkinVars["scarf"] = {
		weight = 100,
		special = ScarfBattle,
		func_priority_ext = ScarfPriority
	}
	print("Scarf The Wolf Battle Mode support has been added!")
end)