//Beggining Hud
local function hud_abilitytable(v, player)
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
	and not player.powers[pw_carry]
	and not (CBW_Battle)
	and player.playerstate == PST_LIVE
	and not player.gotflag
		if player.charability == CA_NONE
		and not (player.pflags & PF_THOKKED)
		and not player.armaform
		and not player.mo.sworddash
			v.drawString(15, 56, "Ability: Float Dash", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_REDMAP)
		elseif player.charability == CA_NONE
		and not player.mo.sworddash
		and not player.armaform
			v.drawString(15, 56, "Ability: Gravity Jump", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_GRAYMAP)
		elseif player.charability == CA_NONE
		and player.armaform == true
			v.drawString(15, 56, "Ability: Parry Fly", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP)
		end
		if player.mo.sworddash
			v.drawFill(15, 66, player.mo.sworddash/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		if player.mo.swordjump
			v.drawFill(15, 66, player.mo.swordjump/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		if player.mo.flamedoublejump
			v.drawFill(15, 66, player.mo.flamedoublejump/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
	and not player.powers[pw_carry]
	and player.playerstate == PST_LIVE
		if (player.speed > 50*FRACUNIT)
			if (leveltime % 2 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%8)/2)), V_80TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 3 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%4)/6)), V_70TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 4 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%5)/6)), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 5 == 0)
				v.drawScaled(0,0,  65355,v.cachePatch("SCRFSP"+tostring((leveltime%8)/5)), V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 6 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%5)/5)), V_30TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 7 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%4)/2)), V_30TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 8 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("SCRFSP"+tostring((leveltime%8)/4)), V_20TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			end
		end
	end
end

hud.add(hud_abilitytable)

//Hud in Battle Mode fix
local function hud_abilitytable2(v, player)
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
	and not player.powers[pw_carry]
	and (CBW_Battle)
	and player.playerstate == PST_LIVE
	and not (player.gotflag or player.gotcrystal)
		//Fixing a Hud in Battle Mode
		if player.charability == CA_NONE
		and not (player.pflags & PF_THOKKED)
		and not player.armaform
			v.drawString(15, 76, "Ability: Float Dash", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_REDMAP)
		elseif player.charability == CA_DOUBLEJUMP
		and not player.armaform
			v.drawString(15, 76, "Ability: Double Jump", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_BLUEMAP)
		elseif player.charability == CA_NONE
		and not player.mo.sworddash
		and not player.armaform
			v.drawString(15, 76, "Ability: Gravity Jump", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_GRAYMAP)
		elseif player.charability == CA_NONE
		and player.armaform == true
			v.drawString(15, 76, "Ability: Parry Fly", V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP)
		end
		if player.mo.sworddash
			v.drawFill(15, 86, player.mo.sworddash/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		if player.mo.swordjump
			v.drawFill(15, 86, player.mo.swordjump/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		//Fixing a hud arma form in Battle Mode
		//Why not?
		if player.mo.flamedoublejump
			v.drawFill(15, 86, player.mo.flamedoublejump/3, 32, V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
end

hud.add(hud_abilitytable2)